type 'a t = 'a list;;

let hd = function
 | x :: _ -> x
 | _ -> failwith "Lst.hd: empty list"
;;
let tl = function
 | _ :: xs -> xs
 | _ -> failwith "Lst.tl: empty list"
;;
let rec append xs ys = if xs = [] then ys else hd xs :: append (tl xs) ys;;
let rec init i l = if l <= 0 then [] else i :: init i (l - 1);;
let rec take n xs =
 if n <= 0 then [] else match xs with
  | [] -> []
  | x :: xs -> x :: take (n - 1) xs
;;
let rec drop n xs =
 if n <= 0 then xs else match xs with
  | [] -> []
  | _ :: xs -> drop (n - 1) xs
;;
let split_at n xs = (take n xs, drop n xs);;
let rec map f = function
 | [] -> []
 | x :: xs -> f x :: map f xs
;;
let rec fold f b = function
 | [] -> b
 | x :: xs -> f x (fold f b xs)
;;
let rec fold_left f b = function
 | [] -> b
 | x :: xs -> fold_left f (f b x) xs
;;
let rec filter p = function
 | [] -> []
 | x :: xs -> if p x then x :: filter p xs else filter p xs
;;
